
			      /* Make Mac File system */

			      /* Usage */

void main(int argc, char ** argv) {

  int dev, blocksize;
  long nr_sectors;
  MOUNT_RECORD mnt;
  struct volinfo  *pvib;
  BYTE buffer[512];
  

  if (argc != 6 ) {
    printf("usage : macmkfs device partnum volumename sectors blocksize\n");
    exit(1);
  }

  sscanf(argv[2], "%d", &partnum);
  sscanf(argv[3], "%ld", &nr_sectors);
  scanf(argv[4], "%d", &blocksize);

  if(nr_sectors < = 0  || (blocksize % 512) != 0) {
    printf("Bad sector number or blocksize\n");
    exit(1);
  }

  bzero(&mnt, sizeof(MOUNT_RECORD));
  
  err = initreadwrite(argv[1], partnum, &mnt);
  if(err) {
    printf("Cannot open the device %s\n", argv[1]);
    exit(1);
  }


			      /* Volume info */
  pvib =  & mnt.vib;

  
  PutWord(0x4244,    buffer + 0);
  PutLongWord(now(), );
  PutLongWord(now(), & pvib->Lsmod);
  PutWord(3,  & pvib->VBMSt);

  firstblock_sect = (((nr_sectors + 7) / 8) + 511) / 512 + 3;
			      /* Round it up */
  sect_per_block = blocksize / 512;
  firstblock_sect = (firstblock_sect + sect_per_block - 1) / sect_per_block *
                              sect_per_block;
  nr_sectors -= ((nr_sectors - firstblock_sect) % sect_per_block);

  
  PutWord((WORD)(nr_sectors / sect_per_block,  & pvib->NmAlBlks);
  
  PutLongWord(blocksize,  & pvib->AlBlkSiz);
  
  PutLongWord(3 * blocksize,  & pvib->ClpSiz);

  
  PutWord(firstblock_sect,  & pvib->AlBlSt);
  
  PutLongWord(10,  & pvib->NxtCNID);

  PutString(argv[3], & pvib->VNlen);

			      /* 1% of the disk will be the BTree */
  tree_clump = nr_sectors * 512 / 100;
  PutLongWord(tree_clump,  & pvib->XTClpSiz);
  PutLongWord(tree_clump,  & pvib->CTClpSiz);


			      /* Extents BTree */
  ptree = & mnt.extent;

  PutWord(20 ,  & ptree->bth.RecLen);	  
  PutWord(512,  & ptree->bth.NodeSize);
  PutWord(7,    & ptree->bth.KeyLen);
  PutLongWord(tree_clump / 512, & ptree->bth.NNodes);
  PutLongWord(tree_clump / 512 - 1, & ptree->bth.Free);

			      /* Catalog BTree */
  ptree = & mnt.catalog;

  PutWord(20 ,  & ptree->bth.RecLen);	  
  PutWord(512,  & ptree->bth.NodeSize);
  PutWord(37,    & ptree->bth.KeyLen);
  PutLongWord(tree_clump / 512, & ptree->bth.NNodes);
  PutLongWord(tree_clump / 512 - 1, & ptree->bth.Free);
	  
	  /* Flush the disk */
  	  
	  






